Index: trunk/ab5.0/ablib/src/Classes/System/Collections/ArrayList.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Collections/ArrayList.ab	(revision 580)
+++ trunk/ab5.0/ablib/src/Classes/System/Collections/ArrayList.ab	(revision 582)
@@ -1,5 +1,3 @@
 ' Classes/System/Collections/ArrayList.ab
-
-#require <Classes/System/Collections/misc.ab>
 
 Namespace System
@@ -140,9 +138,5 @@
 		size++
 	End Function
-
-	Virtual Sub AddRange(c As ICollection)
-		' TODO: 実装
-	End Sub
-
+/*
 	Const Virtual Function BinarySearch(x As Object) As Long
 		' TODO: 実装
@@ -183,5 +177,5 @@
 		End If
 	End Function
-
+*/
 	/*Override*/ Virtual Sub Clear()
 		size = 0
@@ -245,8 +239,4 @@
 	End Sub
 
-	Virtual Sub InsertRange(index As Long, c As ICollection)
-		' TODO: 実装
-	End Sub
-
 	/*Const*/ Virtual Function LastIndexOf(object As Object) As Long
 		LastIndexOf(object, 0, size)
@@ -286,17 +276,5 @@
 	End Sub
 
-	Virtual Sub SetRange(index As Long, c As ICollection)
-		' TODO: 実装
-	End Sub
-
 	Virtual Sub Sort()
-		' TODO: 実装
-	End Sub
-
-	Virtual Sub Sort(c As IComparer)
-		Sort(0, size, c)
-	End Sub
-
-	Virtual Sub Sort(index As Long, count As Long, c As IComparer)
 		' TODO: 実装
 	End Sub
@@ -309,28 +287,4 @@
 	Override Function ToString() As String
 		Return "System.Collections.ArrayList"
-	End Function
-
-	' --------------------------------
-	' static methods
-	Static Function Adapter(l As IList) As ArrayList
-		' TODO: 実装
-	End Function
-
-	Static Function FixedSize(l As ArrayList) As ArrayList
-		' TODO: 実装
-	End Function
-
-	Static Function FixedSize(l As IList) As IList
-		' TODO: 実装
-		'Return FixedSize(Adapter(l))
-	End Function
-
-	Static Function ReadOnly(l As ArrayList) As ArrayList
-		' TODO: 実装
-	End Function
-
-	Static Function ReadOnly(l As IList) As IList
-		' TODO: 実装
-		'Return ReadOnly(Adapter(l))
 	End Function
 
@@ -342,14 +296,4 @@
 		Next
 	End Function
-
-	Static Function Synchronized(l As ArrayList) As ArrayList
-		' TODO: 実装
-	End Function
-
-	Static Function Synchronized(l As IList) As IList
-		' TODO: 実装
-		'Return Synchronized(Adapter(l))
-	End Function
-
 End Class
 
Index: trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/Dictionary.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/Dictionary.ab	(revision 580)
+++ trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/Dictionary.ab	(revision 582)
@@ -1,5 +1,3 @@
 'Classes/System/Collections/Generic/Dictionary.ab
-
-'#require <Classes/System/Collections/Generic/EqualityComparer.ab>
 
 Namespace System
Index: trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/List.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/List.ab	(revision 580)
+++ trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/List.ab	(revision 582)
@@ -96,4 +96,17 @@
 	*/
 	Override Sub Operator[] ( index As Long, item As T )
+		Item[index] = item
+	End Sub
+	Override Function Operator[] ( index As Long ) As T
+		Return Item[index]
+	End Function
+
+	/*!
+	@brief	インデクサ
+	@author	Egtra
+	@date	2008/08/04
+	@param	インデックス
+	*/
+	Override Sub Item( index As Long, item As T )
 		If 0 <= index And index < capacity Then
 			items[index]=item
@@ -102,5 +115,5 @@
 		End If
 	End Sub
-	Override Function Operator[] ( index As Long ) As T
+	Override Function Item( index As Long ) As T
 		If 0 <= index And index < capacity Then
 			Return items[index]
@@ -109,5 +122,4 @@
 		End If
 	End Function
-
 	/*!
 	@brief	ポインタ型へのキャスト
Index: trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/Queue.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/Queue.ab	(revision 580)
+++ trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/Queue.ab	(revision 582)
@@ -5,5 +5,5 @@
 
 Class Queue<T>
-	Implements IEnumerable<T>, IEnumerator<T>, System.Collections.ICollection
+	Implements IEnumerable<T>
 
 	items As *T
@@ -28,23 +28,5 @@
 	End Sub
 
-	/*!
-	@brief	Queueに格納されている要素の数を取得
-	@author	NoWest
-	@date	2008/07/20
-	*/
-	Override Function Count () As Long
-		Return This.count
-	End Function
-
 Public
-	/*!
-	@brief	Queueからすべての要素を削除する
-	@author	NoWest
-	@date	2008/07/20
-	*/
-	Sub Clear ()
-		This.count = 0
-	End Sub
-
 	'ある要素が Queue内に存在するかどうかを判断
 /*	Override Function Contains ( item As T ) As Boolean
Index: trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/Stack.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/Stack.ab	(revision 580)
+++ trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/Stack.ab	(revision 582)
@@ -5,5 +5,5 @@
 
 Class Stack<T>
-	Implements IEnumerable<T>, IEnumerator<T>, System.Collections.ICollection
+	Implements IEnumerable<T>
 
 	items As *T
@@ -27,13 +27,4 @@
 		End If
 	End Sub
-
-	/*!
-	@brief	Stackに格納されている要素の数を取得
-	@author	NoWest
-	@date	2008/07/20
-	*/
-	Override Function Count () As Long
-		Return This.count
-	End Function
 
 Public
Index: trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/misc.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/misc.ab	(revision 580)
+++ trunk/ab5.0/ablib/src/Classes/System/Collections/Generic/misc.ab	(revision 582)
@@ -42,5 +42,7 @@
 	Abstract Function Operator[] ( index As Long ) As T
 
-	' Methods
+	Abstract Sub Item ( index As Long, item As T )
+	Abstract Function Item ( index As Long ) As T
+
 	Abstract Function IndexOf ( item As T ) As Long
 	Abstract Sub Insert ( index As Long, item As T )
Index: trunk/ab5.0/ablib/src/Classes/System/Collections/misc.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Collections/misc.ab	(revision 580)
+++ trunk/ab5.0/ablib/src/Classes/System/Collections/misc.ab	(revision 582)
@@ -1,49 +1,6 @@
 ' Classes/System/Collections/misc.ab
-
-#ifndef __SYSTEM_COLLECTIONS_MISC_AB__
-#define __SYSTEM_COLLECTIONS_MISC_AB__
 
 Namespace System
 Namespace Collections
-
-Interface ICollection
-	Inherits IEnumerable
-	' Properties
-	Function Count() As Long
-	'/*Const*/ Function IsSynchronized() As Boolean
-	' Function SyncRoot() As ...
-	' Methods
-	' Sub CopyTo(ByRef array As ..., index As Long)
-End Interface
-
-Interface IComparer
-	' Methods
-	Function Compare(ByRef x As Object, ByRef y As Object) As Long
-End Interface
-
-Interface IDictionary
-	Inherits ICollection /*, IEnumerable */
-	' Methods
-	Sub Add(ByRef key As Object, ByRef value As Object)
-	Sub Clear()
-	/*Const*/ Function Contains(ByRef key As Object) As Boolean
-'	/*Const*/ Function GetEnumerator() As *IDictionaryEnumerator
-	/*Const*/ Function Remove(ByRef key As Object) As Boolean
-	' Properties
-	/*Const*/ Function IsFixedSize() As Boolean
-	/*Const*/ Function IsReadOnly() As Boolean
-'	/*Const*/ Function Operator [](ByRef key As Object) As *Object
-'	Sub Operator []=(ByRef key As Object, ByRef value As Object)
-	/*Const*/ Function Keys() As *ICollection
-	/*Const*/ Function Values() As ICollection
-End Interface
-
-Interface IDictionaryEnumerator
-	Inherits IEnumerator
-	' Properties
-	/*Const*/ Function Entry() As DictionaryEntry
-	/*Const*/ Function Key() As *Object
-	/*Const*/ Function Value() As *Object
-End Interface
 
 Interface IEnumerable
@@ -60,12 +17,6 @@
 End Interface
 
-Interface IEqualityComparer
-	' Methods
-	Function Equals(ByRef x As Object, ByRef y As Object) As Boolean
-	Function GetHashCode(ByRef obj As Object) As Long
-End Interface
-
 Interface IList
-	Inherits ICollection /*, IEnumerable */
+	'Inherits /*, IEnumerable */
 	' Methods
 	'Function Add(value As *Object) As Long
@@ -83,40 +34,4 @@
 End Interface
 
-Class DictionaryEntry
-Public
-	' /*Const*/ructors
-	Sub DictionaryEntry()
-		k = 0
-		v = 0
-	End Sub
-
-	Sub DictionaryEntry(ByRef key As Object, ByRef value As Object)
-		k = VarPtr(key)
-		v = VarPtr(value)
-	End Sub
-
-	' Properties
-	/*Const*/ Function Key() As *Object
-		Return k
-	End Function
-
-	Sub Key(ByRef key As Object)
-		k = VarPtr(key)
-	End Sub
-
-	/*Const*/ Function Value() As *Object
-		Return v
-	End Function
-
-	Sub Value(ByRef value As Object)
-		v = VarPtr(value)
-	End Sub
-Private
-	k As *Object
-	v As *Object
-End Class
-
 End Namespace 'Collections
 End Namespace 'System
-
-#endif '__SYSTEM_COLLECTIONS_MISC_AB__