Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Class.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Class.cpp	(revision 596)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Class.cpp	(revision 597)
@@ -1,16 +1,3 @@
 #include "stdafx.h"
-
-#include <Source.h>
-#include <Class.h>
-#include <Compiler.h>
-
-#include "../common.h"
-#ifdef _AMD64_
-#include "../../compiler_x64/opcode.h"
-#else
-#include "../../compiler_x86/opcode.h"
-#endif
-
-using namespace ActiveBasic::Compiler;
 
 void CClass::Using() const
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Const.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Const.cpp	(revision 596)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Const.cpp	(revision 597)
@@ -1,7 +1,3 @@
 #include "stdafx.h"
-
-#include <Compiler.h>
-
-using namespace ActiveBasic::Compiler;
 
 double CConst::GetDoubleData(){
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Delegate.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Delegate.cpp	(revision 596)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Delegate.cpp	(revision 597)
@@ -1,5 +1,3 @@
 #include "stdafx.h"
-
-#include <Delegate.h>
 
 bool Delegate::IsSimilar( const Delegate &dgt ) const
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Meta.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Meta.cpp	(revision 596)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Meta.cpp	(revision 597)
@@ -1,5 +1,3 @@
 #include "stdafx.h"
-
-#include <Compiler.h>
 
 void Meta::Clear()
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Method.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Method.cpp	(revision 596)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Method.cpp	(revision 597)
@@ -1,6 +1,3 @@
 #include "stdafx.h"
-
-#include <Class.h>
-
 
 DynamicMethod::OverrideResult::EnumType DynamicMethod::Override( const UserProc *pUserProc, Prototype::Accessibility accessibility, bool isOverrideModifier )
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/NativeCode.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/NativeCode.cpp	(revision 596)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/NativeCode.cpp	(revision 597)
@@ -1,5 +1,3 @@
 #include "stdafx.h"
-
-#include <Compiler.h>
 
 #define BREAK_EIP(checkEip)  (obp+0x00401000>=checkEip)
@@ -108,5 +106,5 @@
 }
 
-void NativeCode::NextSourceLine( int currentSourceIndex )
+void NativeCode::NextSourceLine( int currentSourceIndex, int nowLine )
 {
 	if( sourceLines.size() )
@@ -114,5 +112,5 @@
 		if( sourceLines.back().GetNativeCodePos() == GetSize() )
 		{
-			sourceLines.back().SetSourceCodePos( cp );
+			sourceLines.back().SetSourceCodePos( nowLine );
 			return;
 		}
@@ -135,5 +133,5 @@
 			GetSize(),
 			currentSourceIndex,
-			cp,
+			nowLine,
 			sourceLineType
 		)
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/ObjectModule.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/ObjectModule.cpp	(revision 596)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/ObjectModule.cpp	(revision 597)
@@ -81,16 +81,4 @@
 #include <ObjectModule.h>
 
-#include <Exception.h>
-#include <logger.h>
-#include <Configuration.h>
-#include <CodeGenerator.h>
-#include <Messenger.h>
-#include <Linker.h>
-#include <Compiler.h>
-#include <Debugger.h>
-#include <Program.h>
-#include <LexicalAnalyzer.h>
-
-
 
 void ObjectModule::StaticLink( ObjectModule &objectModule )
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Parameter.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Parameter.cpp	(revision 596)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Parameter.cpp	(revision 597)
@@ -1,4 +1,3 @@
 #include "stdafx.h"
-
 
 bool Parameter::Equals( const Parameter &param, bool isContravariant ) const
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Procedure.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Procedure.cpp	(revision 596)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Procedure.cpp	(revision 597)
@@ -1,16 +1,3 @@
 #include "stdafx.h"
-
-#include <Compiler.h>
-#include <Procedure.h>
-
-#include "../common.h"
-#ifdef _AMD64_
-#include "../../compiler_x64/opcode.h"
-#else
-#include "../../compiler_x86/opcode.h"
-#endif
-
-using namespace ActiveBasic::Compiler;
-
 
 bool UserProc::IsEqualForOverride( const Types &actualTypeParametersForThisProc, const UserProc *pUserProc ) const
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Type.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Type.cpp	(revision 596)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Type.cpp	(revision 597)
@@ -1,5 +1,3 @@
 #include "stdafx.h"
-
-#include <Class.h>
 
 const int Type::basicTypeList[] = {
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/TypeDef.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/TypeDef.cpp	(revision 596)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/TypeDef.cpp	(revision 597)
@@ -1,6 +1,3 @@
 #include "stdafx.h"
-
-#include <TypeDef.h>
-#include <Compiler.h>
 
 TypeDef::TypeDef( const NamespaceScopes &namespaceScopes, const std::string &name, const std::string &baseName, const Type &baseType )
Index: trunk/ab5.0/abdev/BasicCompiler_Common/src/Variable.cpp
===================================================================
--- trunk/ab5.0/abdev/BasicCompiler_Common/src/Variable.cpp	(revision 596)
+++ trunk/ab5.0/abdev/BasicCompiler_Common/src/Variable.cpp	(revision 597)
@@ -1,6 +1,3 @@
 #include "stdafx.h"
-
-#include <Compiler.h>
-#include <Variable.h>
 
 Variable::Variable( const Symbol &symbol, const Type &type, bool isConst, bool isRef, const std::string &paramStrForConstructor, bool hasInitData )