Index: trunk/ab5.0/abdev/compiler_x64/compiler_x64.vcproj
===================================================================
--- trunk/ab5.0/abdev/compiler_x64/compiler_x64.vcproj	(revision 601)
+++ trunk/ab5.0/abdev/compiler_x64/compiler_x64.vcproj	(revision 603)
@@ -349,20 +349,4 @@
 					>
 					<File
-						RelativePath="..\BasicCompiler_Common\include\Class.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\Const.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\DataTable.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\Delegate.h"
-						>
-					</File>
-					<File
 						RelativePath="..\BasicCompiler_Common\include\Enum.h"
 						>
@@ -373,53 +357,5 @@
 					</File>
 					<File
-						RelativePath="..\BasicCompiler_Common\include\Interface.h"
-						>
-					</File>
-					<File
 						RelativePath="..\BasicCompiler_Common\include\LexicalScope.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\Member.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\Meta.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\Method.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\NativeCode.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\ObjectModule.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\Parameter.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\Procedure.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\Source.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\Type.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\TypeDef.h"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\include\Variable.h"
 						>
 					</File>
@@ -1275,85 +1211,9 @@
 					>
 					<File
-						RelativePath="..\BasicCompiler_Common\src\Class.cpp"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\Const.cpp"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\DataTable.cpp"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\Delegate.cpp"
-						>
-					</File>
-					<File
 						RelativePath="..\BasicCompiler_Common\src\Exception.cpp"
 						>
 					</File>
 					<File
-						RelativePath="..\BasicCompiler_Common\src\Interface.cpp"
-						>
-					</File>
-					<File
 						RelativePath="..\BasicCompiler_Common\src\LexicalScope.cpp"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\Meta.cpp"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\Method.cpp"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\NativeCode.cpp"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\ObjectModule.cpp"
-						>
-						<FileConfiguration
-							Name="Debug|Win32"
-							>
-							<Tool
-								Name="VCCLCompilerTool"
-								UsePrecompiledHeader="0"
-							/>
-						</FileConfiguration>
-						<FileConfiguration
-							Name="Release|Win32"
-							>
-							<Tool
-								Name="VCCLCompilerTool"
-								UsePrecompiledHeader="0"
-							/>
-						</FileConfiguration>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\Parameter.cpp"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\Procedure.cpp"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\Source.cpp"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\Type.cpp"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\TypeDef.cpp"
-						>
-					</File>
-					<File
-						RelativePath="..\BasicCompiler_Common\src\Variable.cpp"
 						>
 					</File>
@@ -1374,4 +1234,12 @@
 					RelativePath="..\BasicCompiler_Common\src\BoostSerializationSupport.cpp"
 					>
+					<FileConfiguration
+						Name="Debug|Win32"
+						>
+						<Tool
+							Name="VCCLCompilerTool"
+							UsePrecompiledHeader="0"
+						/>
+					</FileConfiguration>
 					<FileConfiguration
 						Name="Release|Win32"